# Generated via
#  `rails generate hyrax:work CrcDataset`
module Hyrax
  # Generated form for CrcDataset
  class CrcDatasetForm < Hyrax::Forms::WorkForm
    self.model_class = ::CrcDataset
    self.terms -= [
      # Fields not interested in
      :creator, :contributor, :rights_notes, :rights_statement,
      :access_right, :date_created, :identifier, :based_near, :related_url, :source,
      # Fields interested in, but removing to re-order
      :title, :alternative_title, :resource_type, :description, :abstract, :keyword, :license,
      :publisher, :subject, :language,
      # Fields that are not displayed
      # :import_url, :date_modified, :date_uploaded, :depositor, :bibliographic_citation, :label, :relative_path
    ]

    self.terms += [
      # Adding all fields in order of display in form
      :parent_work_id,
      :work_type,
      :doi,
      :title,
      :alternative_title,
      :complex_person,
      :abstract,
      :coverage,
      :description,
      :complex_identifier,
      :complex_date,
      :modality,
      :complex_subject,
      :approval_number,
      :keyword,
      :crc_resource_type,
      :subject,
      :publisher,
      :language,
      :complex_funding_reference,
      :complex_relation,
      :software_version,
      :extra_information
    ]

    self.required_fields -= [
      # Fields not interested in
      :creator, :rights_statement,
      # Fields interested in, but removing to re-order
      :title
    ]

    self.required_fields += [
      # Adding all required fields in order of display in form
      :title, :complex_person, :abstract, :keyword, :crc_resource_type, :modality, :coverage, :license
    ]

    protected

    def self.permitted_date_params
      [:id,
       :_destroy,
       {
         date: [],
         description: []
       }
      ]
    end

    def self.permitted_identifier_params
      [:id,
       :_destroy,
       {
         identifier: [],
         scheme: [],
         label: []
       }
      ]
    end

    def self.permitted_person_params
      [:id,
       :_destroy,
       :corresponding_author,
       :display_order,
       {
         last_name: [],
         first_name: [],
         name: [],
         role: [],
         orcid: [],
         affiliation: [],
       }
      ]
    end

    def self.permitted_relation_params
      [:id,
       :_destroy,
       {
         title: [],
         url: [],
         complex_identifier_attributes: permitted_identifier_params,
         relationship: []
       }
      ]
    end

    def self.permitted_fundref_params
      [:id,
       :_destroy,
       {
         funder_identifier: [],
         funder_name: [],
         award_number: [],
         award_uri: [],
         award_title: []
       }
      ]
    end

    def self.permitted_subject_params
      [:id,
       :_destroy,
       {
         subject_identifier: [],
         subject_species: [],
         subject_type: [],
         subject_sex: [],
         subject_age: [],
       }
      ]
    end

    def self.build_permitted_params
      permitted = super
      permitted << :doi
      permitted << :modality
      permitted << :crc_resource_type
      permitted << :coverage
      permitted << :approval_number
      permitted << :extra_information
      permitted << :software_version
      permitted << :parent_work_id
      permitted << :work_type
      permitted << { complex_date_attributes: permitted_date_params }
      permitted << { complex_identifier_attributes: permitted_identifier_params }
      permitted << { complex_person_attributes: permitted_person_params }
      permitted << { complex_relation_attributes: permitted_relation_params }
      permitted << { complex_funding_reference_attributes: permitted_fundref_params }
      permitted << { complex_subject_attributes: permitted_subject_params }
    end
  end
end
