# Generated via
#  `rails generate hyrax:work CrcDataset`
class CrcDatasetIndexer < RdmsIndexer
  # This indexes the default metadata. You can remove it if you want to
  # provide your own metadata and indexing.
  include Hyrax::IndexesBasicMetadata

  # Fetch remote labels for based_near. You can remove this if you don't want
  # this behavior
  include Hyrax::IndexesLinkedMetadata

  # Custom indexers for crc dataset model
  include ComplexField::PersonIndexer
  include ComplexField::DateIndexer
  include ComplexField::IdentifierIndexer
  include ComplexField::FundrefIndexer
  include ComplexField::RelationIndexer
  include ComplexField::SubjectIndexer

  def self.facet_fields
    # solr fields that will be treated as facets
    super.tap do |fields|
      fields << Solrizer.solr_name('modality', :facetable)
      fields << Solrizer.solr_name('crc_resource_type', :facetable)
      fields << Solrizer.solr_name('coverage', :facetable)
      fields.concat ComplexField::IdentifierIndexer.identifier_facet_fields
      fields.concat ComplexField::DateIndexer.date_facet_fields
      fields.concat ComplexField::PersonIndexer.person_facet_fields
      fields.concat ComplexField::FundrefIndexer.fundref_facet_fields
      fields.concat ComplexField::SubjectIndexer.subject_facet_fields
    end
  end

  def self.search_fields
    # solr fields that will be used for a search
    super.tap do |fields|
      fields << Solrizer.solr_name('modality', :stored_searchable)
      fields << Solrizer.solr_name('crc_resource_type', :stored_searchable)
      fields << Solrizer.solr_name('coverage', :stored_searchable)
      fields.concat ComplexField::IdentifierIndexer.identifier_search_fields
      fields.concat ComplexField::DateIndexer.date_search_fields
      fields.concat ComplexField::PersonIndexer.person_search_fields
      fields.concat ComplexField::FundrefIndexer.fundref_search_fields
      fields.concat ComplexField::SubjectIndexer.subject_search_fields
    end
  end

  def self.show_fields
    # solr fields that will be used to display results on the record page
    super.tap do |fields|
      fields << Solrizer.solr_name('modality', :stored_searchable)
      fields << Solrizer.solr_name('crc_resource_type', :stored_searchable)
      fields << Solrizer.solr_name('coverage', :stored_searchable)
      fields.concat ComplexField::IdentifierIndexer.identifier_show_fields
      fields.concat ComplexField::DateIndexer.date_show_fields
      fields.concat ComplexField::PersonIndexer.person_show_fields
      fields.concat ComplexField::FundrefIndexer.fundref_show_fields
      fields.concat ComplexField::SubjectIndexer.subject_show_fields
    end
  end
end
